/* JSGal v0.40: Copyright (c) 2004 by Andreas S. Krebs (jsgal@sberk.net) */
// below are the configuration parameter
var imgrows=3;
var imgcols=3;
var pagesinrow=20;
var thumbdir="thumbs/";
var imagedir="images/";
var thumbheight=150;	// if you change this you probably also want to change the heigth of the thumbcell in the styles!!
var thumbwidth=null;	// use null to resize keeping aspect ratio
var imageheight=600;
var imagewidth=null;	// use null to resize keeping aspect ratio
var imagetarget=null;	// the target browser window name for displaying original image or null for current window

// here starts the real coding
var imgspage=imgrows*imgcols;
var numpages=Math.ceil(images.length/imgspage);
var numpagerows=Math.ceil(numpages/pagesinrow);

// here are the display modes
var MODE_PAGE		=1;
var MODE_SHOWALL	=2;
var MODE_IMAGE		=3;

// here are the variables we store the current values in
var current_mode	=-1;
var current_page	=-1;
var current_image	=-1;

function showPage(page)
{
  if(page>numpages)
    page=numpages;

  if(page<1)
    page=1;

  renderPage(MODE_PAGE, page, -1);
}

function showAll()
{
  renderPage(MODE_SHOWALL, -1, -1)
}

function showImage(imgno)
{
  if(imgno>=images.length)
    imgno=images.length-1;

  if(imgno<0)
    imgno=0;

  renderPage(MODE_IMAGE, Math.floor(imgno/imgspage)+1, imgno);
}

function appendSimpleElement(parent, id, tag)
{
  var el=document.createElement(tag);

  if(id)
    setAttribute(el, 'id', id);
    
  if(parent)
    parent.appendChild(el);

  return el;
}

function appendText(parent, text)
{
  var el=document.createTextNode(text);

  if(parent)
    parent.appendChild(el);

  return el;
}

function updateText(parentId, text)
{
  var el=document.getElementById(parentId);

  // note: we expect the text element to be the first element !!!
  if(el && el.firstChild && el.firstChild.nodeType==3)
    el.firstChild.nodeValue=text;
}

/* this a workaround for the bugs in IE's setAttribute */
function setAttribute(node, name, value) 
{
  // to be on the save side we always set attributes again
  if(value)
  {
    var attr=document.createAttribute(name);
    attr.value=value;

    node.setAttributeNode(attr);
  }
  else
    node.removeAttribute(name);
} 

function updateAttributes(elId)
{
  var el=document.getElementById(elId);

  if(el)
  {
    for(var i=1; (i+1)<arguments.length; i+=2) 
    {
      if(el.getAttribute(arguments[i])!=arguments[i+1])
        setAttribute(el, arguments[i], arguments[i+1]);
    }
  }
}

function appendElement(parent, id, tag, text)
{
  var el=appendSimpleElement(parent, id, tag);

  for(var i=4; (i+1)<arguments.length; i+=2) 
  {
    setAttribute(el, arguments[i], arguments[i+1]);
  }

  if(text)
    appendText(el, text);

  return el;
}

function appendNavLink(parent, id, title, page)
{
  if(page>=1 && page<=numpages)
    return appendElement(parent, id, "a", title, "class", "enabled", "href", "javascript:parent.showPage("+page+");");
  else
    return appendElement(parent, id, "a", title, "class", "disabled");
}

function updateNavLink(elId, page)
{
  var st, ref;

  if(page>=1 && page<=numpages)
  {
    st="enabled";
    ref="javascript:parent.showPage("+page+");";
  }
  else
  {
    st="disabled";
    ref=null;
  }

  updateAttributes(elId, "class", st, "href", ref);
}

function appendShowallLink(parent, id, title)
{
  return appendElement(parent, id, "a", title, "class", "enabled", "href", "javascript:parent.showAll();");
}

function appendImageNavLink(parent, id, title, imgno)
{
  if(imgno>=0 && imgno<images.length)
    return appendElement(parent, id, "a", title, "class", "enabled", "href", "javascript:parent.showImage("+imgno+");");
  else
    return appendElement(parent, id, "a", title, "class", "disabled");
}

function updateImageNavLink(elId, imgno)
{
  var st, ref;

  if(imgno>=0 && imgno<images.length)
  {
    st="enabled";
    ref="javascript:parent.showImage("+imgno+");";
  }
  else
  {
    st="disabled";
    ref=null;
  }

  updateAttributes(elId, "class", st, "href", ref);
}

function appendImageLink(parent, id, imgno)
{
  var imgsrc=thumbdir+images[imgno];
  var visible=true;

  if(imgno>=images.length)
  {
    imgsrc=null;
    visible=false;
  }

  var el=appendElement(parent, id, "a", null, "class", "enabled", "href", "javascript:parent.showImage("+imgno+");");
  appendElement(el, id+"_img", "img", null, "class", "thumb", "src", imgsrc, "width", thumbwidth, "height", thumbheight);
  appendSimpleElement(el, id+"_br", "br");
  appendElement(el, id+"_span", "span", images[imgno], "class", "thumbfooter");

  setElementVisible(el, visible);
} 

function updateImageLink(elId, imgno)
{
  var imgsrc=thumbdir+images[imgno];
  var visible=true;

  if(imgno>=images.length)
  {
    imgsrc=null;
    visible=false;
  }

  var el=document.getElementById(elId);
  setAttribute(el, "href", "javascript:parent.showImage("+imgno+");");
  updateAttributes(elId+"_img", "src", imgsrc, "width", thumbwidth, "height", thumbheight);
  updateText(elId+"_span", images[imgno]);

  setElementVisible(el, visible);
}

function setElementVisible(el, visible)
{
  var disp=visible ? "" : "none";

  if(el && el.style.display!=disp)
    el.style.display=disp;
}

function replaceNodes(elId, childEl)
{
  if(childEl)
  {
    var el=document.getElementById(elId);

    if(el)
    {
      if(el.firstChild)
        el.replaceChild(childEl, el.firstChild);
      else
        el.appendChild(childEl);
    }
  }
}

function createNavigation(mode, pageno)
{
  var rowEl, colEl, bodyEl, navEl;
  var prevStyle=(pageno>1) ? "navpage" : "navpage_disabled";
  var nextStyle=(pageno<numpages) ? "navpage" : "navpage_disabled";

  // check if really a create is required or maybe a simple update will do 
  if(mode==current_mode || (mode!=MODE_SHOWALL && (current_mode==MODE_IMAGE || current_mode==MODE_PAGE)))
  {
    if(mode!=current_mode || current_page!=pageno)
    {
      updateAttributes("pg_prev", "class", prevStyle);
      updateNavLink("pg_prev_link", pageno-1);

      updateAttributes("pg_next", "class", nextStyle);
      updateNavLink("pg_next_link", pageno+1);

      if(current_page!=pageno)
      {
        updateAttributes("pg_"+current_page, "class", "jumppage");
        updateNavLink("pg_"+current_page+"_link", current_page);
      }

      updateAttributes("pg_"+pageno, "class", "jumppage_active");
      updateNavLink("pg_"+pageno+"_link", (mode==MODE_PAGE) ? -1 : pageno);
    }

    return null;
  }

  // now let's create the navigation
  navEl=appendElement(null, "ntab", "table", null, "class", "navigation", "width", "100%");
  bodyEl=appendSimpleElement(navEl, "ntab_tb", "tbody");

  // create the with page links
  var inx=1;
  var rowend=0;
  for(var r=0; r<numpagerows; r++)
  {
    rowEl=appendSimpleElement(bodyEl, "ntab_tr"+r, "tr");

    // create the previous link in first row
    if(r==0 && mode!=MODE_SHOWALL && numpages>1)
    {
      colEl=appendElement(rowEl, "pg_prev", "td", null, "class", prevStyle, "rowspan", numpagerows);
      appendNavLink(colEl, "pg_prev_link", "Previous", pageno-1);
    }

    rowend+=pagesinrow;
    for(; inx<=rowend && inx<=numpages; inx++)
    {
      var style=(inx==pageno) ? "jumppage_active" : "jumppage";	  // is this the current page ?
      var pgn=((inx==pageno) && (mode==MODE_PAGE)) ? -1 : inx;    // in page mode we don't create a link

      colEl=appendElement(rowEl, "pg_"+inx, "td", null, "class", style);
      appendNavLink(colEl, "pg_"+inx+"_link", inx, pgn);
    }

    // create the next link in first row
    if(r==0 && mode!=MODE_SHOWALL && numpages>1)
    {
      if(numpages>1)
      {
        colEl=appendElement(rowEl, "showall", "td", null, "class", "showAll", "rowspan", numpagerows);
        appendShowallLink(colEl, "showall_link", "Show All");
      }

      colEl=appendElement(rowEl, "pg_next", "td", null, "class", nextStyle, "rowspan", numpagerows);
      appendNavLink(colEl, "pg_next_link", "Next", pageno+1);
    }
  }

  return navEl;
}

function createThumbGallery(mode, pageno)
{
  var rowEl, colEl, bodyEl, mainEl;

  // create the page with thumbs
  var numrows=imgrows;
  var imgno=(pageno-1)*imgspage;

  // check if really a create is required or maybe a simple update will do 
  if(mode==current_mode)
  {
    if(mode!=MODE_SHOWALL && pageno!=current_page)
    {
      for(var row=0; row<numrows; row++)
      {
        for(var col=0; col<imgcols; col++)
        {
          updateImageLink("img_"+row+"_"+col+"_link", imgno);

          imgno++;
        }
      }
    }

    return null;
  }

  // now let's create the image section
  mainEl=appendElement(null, "gtab", "table", null, "class", "gallery", "width", "100%");
  bodyEl=appendSimpleElement(mainEl, "gtab_tb", "tbody");

  // for showAll we simply increase the rows per page, so that all thumbs fit
  if(mode==MODE_SHOWALL)
  {
    imgno=0;
    numrows=Math.ceil(images.length/imgcols);
  }

  // create rows and cell with thumbs
  for(var row=0; row<numrows; row++)
  {
    rowEl=appendSimpleElement(bodyEl, "gtab_tr"+row, "tr");

    for(var col=0; col<imgcols; col++)
    {
      var id="img_"+row+"_"+col;

      colEl=appendElement(rowEl, id, "td", null, "class", "thumbcell");
      appendImageLink(colEl, id+"_link", imgno);

      imgno++;
    }
  }
 
  return mainEl;
}

function createImageGallery(mode, imgno)
{
  var aEl, rowEl, colEl, bodyEl, mainEl;
  var prevStyle=(imgno>0) ? "img_navpage" : "img_navpage_disabled";
  var nextStyle=(imgno<images.length-1) ? "img_navpage" : "img_navpage_disabled";

  // check if really a create is required or maybe a simple update will do
  if(mode==current_mode)
  {
    updateAttributes("img_prev", "class", prevStyle);
    updateImageNavLink("img_prev_link", imgno-1);

    updateText("image_name", images[imgno]);

    updateAttributes("img_next", "class", nextStyle);
    updateImageNavLink("img_next_link", imgno+1);
       
    updateAttributes("img_nameref", "href", imagedir+images[imgno]);
    updateAttributes("img_imgref", "src", imagedir+images[imgno], "width", imagewidth, "height", imageheight);

    return null;
  }

  // now let's create the image section
  mainEl=appendElement(null, "gtab", "table", null, "class", "gallery", "width", "100%");
  bodyEl=appendSimpleElement(mainEl, "gtab_tb", "tbody");

  // create the page with the image
  rowEl=appendSimpleElement(bodyEl, "gtab_tr0", "tr");

  // create the link for previous image
  colEl=appendElement(rowEl, "img_prev", "td", null, "class", prevStyle);
  appendImageNavLink(colEl, "img_prev_link", "Previous", imgno-1);

  // display image name in the middle
  appendElement(rowEl, "image_name", "td", images[imgno], "class", "img_jumppage_active");

  // create the link for next image
  colEl=appendElement(rowEl, "img_next", "td", null, "class", nextStyle);
  appendImageNavLink(colEl, "img_next_link", "Next", imgno+1);

  // create the row with the image cell
  rowEl=appendSimpleElement(bodyEl, "gtab_tr1", "tr");
  colEl=appendElement(rowEl, "gtab_img", "td", null, "class", "picturecell", "colspan", 3);

  // create a link link to the image containing the image
  aEl=appendElement(colEl, "img_nameref", "a", null, "class", "enabled", "href", imagedir+images[imgno], "target", imagetarget);
  appendElement(aEl, "img_imgref", "img", null, "class", "picture", "src", imagedir+images[imgno], "width", imagewidth, "height", imageheight);
  appendSimpleElement(aEl, "img_br", "br");
  appendElement(aEl, "img_os", "span", "Original size...", "class", "picturefooter");

  return mainEl;
}

// this method renders the complete page (for all modes)
function renderPage(mode, pageno, imgno)
{ 
  var navEl, mainEl;

  // we only set the title if the mode is initial
  if(current_mode<0)
  {
    var titleEl=appendText(null, title);

    replaceNodes("title", titleEl);
  }

  // create the navigation area
  navEl=createNavigation(mode, pageno);
  replaceNodes("nav", navEl);

  // create the gallery area
  if(mode!=MODE_IMAGE)		// page or showall mode
    mainEl=createThumbGallery(mode, pageno, imgno);
  else
    mainEl=createImageGallery(mode, imgno);
  replaceNodes("main", mainEl);

  // now update the variables with the current values
  current_mode=mode;
  current_page=pageno;
  current_image=imgno;

  // now let's save the state in the cookie
  updateJsgalCookie();
}

var JSCOOKIE="jsstyle";

function updateJsgalCookie()
{
  var ck=document.getElementById('styletag').getAttribute('href')+","+current_mode+","+current_page+","+current_image;
  var dt=new Date();

  dt.setFullYear(dt.getFullYear()+1);	// let's set the cookie expiry time 1 year in the future
  
  document.cookie=JSCOOKIE+"="+escape(ck)+"; expires="+dt.toGMTString();  
}

function getJsgalCookie()
{
  var s=document.cookie;
  var inx=s.indexOf(JSCOOKIE+"=");

  if(inx<0)
    return null;
  
  s=s.substring(inx+JSCOOKIE.length+1, s.length);

  inx=s.indexOf(";");
  if(inx>0)
    s=s.substring(0, inx);

  return unescape(s); 
}

function restoreState()
{
  try
  {
    var ck=getJsgalCookie();
    var cssfile, mode=MODE_PAGE, page=1, imgno=-1;

    if(ck)
    {
      var cks=ck.split(",");
   
      cssfile=cks[0];
      if(cks.length>=4)
      {
        mode=parseInt(cks[1]);
        page=parseInt(cks[2]);
        imgno=parseInt(cks[3]);
      } 
    }
    else
      cssfile=document.getElementById('styletag').getAttribute('href');

    setStyle(cssfile);

    // now select style in combo box
    var opts=document.getElementById("stylesel").options;
    for(var i=0; i<opts.length; i++)
      opts[i].selected=(opts[i].value==cssfile);

    // now restore the state of the page
    if(mode==MODE_IMAGE)
      showImage(imgno);
    else if(mode==MODE_SHOWALL)
      showAll();
    else
      showPage(page);
  }
  catch(e)
  {
    // if anything goes wrong we restore the first page
    showPage(1);
  }
}

function setStyle(cssfile)
{
  var st=document.getElementById('styletag');
  st.setAttribute('href', cssfile);

  // now let's save the style in the cookie
  updateJsgalCookie();
}
